var wgtVer = null;
var BASE_URL = "https://ctms.yunzhangdoc.com/app/";
function plusReady() {
	// 获取本地应用资源版本号 
	plus.runtime.getProperty(plus.runtime.appid, function(inf) {
		wgtVer = inf.version;
		console.log("当前应用版本：" + wgtVer);
	});
}
if(window.plus) {
	plusReady();
} else {
	document.addEventListener('plusready', plusReady, false);
}

// 检测更新 
// 实际项目中需要更换为自己服务器的地址 
var checkUrl = BASE_URL + "app/versionUpdate/versionInfo.hf?VersionCode=1";

function checkUpdate() {
	plus.nativeUI.showWaiting("检测更新...");
	var xhr = new XMLHttpRequest();
	xhr.onreadystatechange = function() {
		switch(xhr.readyState) {
			case 4:
				plus.nativeUI.closeWaiting();
				if(xhr.status == 200) {
					var result = eval("(" + xhr.responseText + ")");
					console.log("服务器版本：" + result.data.serverVersion);

					var newVer = result.data.serverVersion;
					if(wgtVer && newVer && (wgtVer != newVer)) {
						if(mui.os.ios) { //跳转appstore
							var url = 'itms-apps://itunes.apple.com/cn/app/hello-h5+/id682211190?l=zh&mt=8'; // HelloH5应用在appstore的地址
							//plus.runtime.openURL(url);
						} else {
							plus.nativeUI.confirm("发现新版本，是否立即下载", function(e) {
								var sure = (e.index == 0) ? "Yes" : "No";
								if(sure == 'Yes') {
									downWgt(); // 下载更新包
								}
							})
						}

					} else {
						//plus.nativeUI.alert("无新版本可更新！");
					}
				} else {
					console.log("检测更新失败！");
					plus.nativeUI.alert("检测更新失败！");
				}
				break;
			default:
				break;
		}
	}
	xhr.open('GET', checkUrl);
	xhr.send();
}
// 下载wgt文件 
// 实际项目中需要更换为自己服务器的地址 
var wgtUrl = BASE_URL + "app/versionUpdate/apkDownLoad.hf";

function downWgt() {
	plus.nativeUI.showWaiting("正在下载更新包...");
	plus.downloader.createDownload(wgtUrl, {
		filename: "_doc/update/"
	}, function(d, status) {
		if(status == 200) {
			console.log("下载wgt成功：" + d.filename);
			//			plus.nativeUI.confirm("升级包下载完成，是否需要升级", function(e) {
			//				var sure = (e.index == 0) ? "Yes" : "No";
			//				if(sure == 'Yes') {
			//					installWgt(d.filename); // 安装wgt包 
			//				}
			//			})
			installWgt(d.filename); // 安装wgt包 
		} else {
			console.log("下载更新包失败！");
			plus.nativeUI.alert("下载更新包失败！");
		}
		plus.nativeUI.closeWaiting();
	}).start();
}
// 更新应用资源 
function installWgt(path) {
	plus.nativeUI.showWaiting("安装中...");
	plus.runtime.install(path, {}, function() {
		plus.nativeUI.closeWaiting();
		console.log("安装wgt文件成功！");
		plus.nativeUI.alert("应用资源更新完成!\n点击确定按钮重启完成升级", function() {
			plus.runtime.restart();
		});
	}, function(e) {
		plus.nativeUI.closeWaiting();
		console.log("安装wgt文件失败[" + e.code + "]：" + e.message);
		plus.nativeUI.alert("安装失败[" + e.code + "]：" + e.message);
	});
}
/* 
 * 差异化升级流程： 
 * 1.启动app后在plusReady里面首先获取app版本 
 * 2.检查服务器版本 
 * 3.服务器版本大于本地app版本下载升级包，提示安装和升级 
 * 4.服务器版本小于等于本地版本时，不做任何操作 
 * 5.重启即可玩升级 
 */