﻿
    var laychat={
    appName : '网上咨询',
    websocketAddress:'wss://chat2.ytlk.shop:443',
    membersUrl  :'https://chat1.ytlk.shop/publics/members',
    sendMessageUrl :'https://chat1.ytlk.shop/publics/sendmessage',
    uploadImageUrl :'https://chat1.ytlk.shop/publics/upload_image',
    uploadFileUrl  :'https://chat1.ytlk.shop/publics/upload_file',
    addFriendUrl   :'https://chat1.ytlk.shop/publics/add_friend',
    removeFriendUrl:'https://chat1.ytlk.shop/publics/remove_friend',
    addGroupUrl    :'https://chat1.ytlk.shop/publics/join_group',
    leaveGroupUrl   :'https://chat1.ytlk.shop/publics/leave_group',
    brief             : false,
    min               : false,
    right             : '0px',
    minRight          : null,
    initSkin          : '',
    isAudio           : false,
    isVideo           : false,
    notice            : false,
    maxLength         : 3000,
    skin              : null,
    copyright         : false,
    isMobile          : false,
    setMin            : false,
    enableAudio       : true,
    enableVideo       : true,
    enableGroup       : true,
    enableFriend      : true,
    voice             : false,
    inited            : 0,
    socket            : null,
    open              : function(){
        if (this.inited) return;
        if(this.isIE6or7()) return;
        this.connect();
        this.initIM();
    },
     isIE6or7 : function(){
        var b = document.createElement('b');
        b.innerHTML = '<!--[if IE 5]><i></i><![endif]--><!--[if IE 6]><i></i><![endif]--><!--[if IE 7]><i></i><![endif]-->';
        return b.getElementsByTagName('i').length === 1;
    },
      connect: function() {
            var falgstr =this.websocketAddress;
            var arr =falgstr.split(':');
            var host= arr[1].replace('//', '');
             if(arr[0] == 'wss'){
               type ='wss';
               var woker = new  Woker(laychat.app_key,{
                   encrypted:true
                   ,enabledTransports: ['wss']
                   ,wsHost:host
                   ,wssPort:arr[2]
                  });
              
             }else{
                 var woker = new  Woker(laychat.app_key,{
                       encrypted:false
                       ,enabledTransports: ['ws']
                       ,wsHost:host
                       ,wsPort:arr[2]
                     });
             }
            
          
             var channel =woker.subscribe('user' + laychat.mine.id);
             // 接受消息
             channel.on('getmessage',function(data){

                 // var msg =$.parseJSON(data.message);
                 layui.layim.getMessage(data.message
                  );
             });

             channel.on('getnow',function(data){
                 $.each(data.message,function(k,v){
                     var obj = $.parseJSON(v);
                     layui.layim.getMessage(obj);  
                 });
             });

             channel.on('addfriend',function(data){
                  data.message.groupid=1;
                  layui.layim.addList(data.message);
             });

             channel.on('removefriend',function(data){
                    layui.layim.removeList(data.message);
             });

          
            var groups =laychat.groupList;

  

             channel.on('addgroup',function(data){
                 groups.push(data.message);
             });
            
             channel.on('livegroup',function(data){
       
             woker.unsubscribe('group'+data.message.id);
                 $.each(groups,function(k,v){
                       if(v.id ==data.message){
                          groups[k] ='';
                       }
                 });
             });

            // console.log(groups);
            // 接受群消息
        
            if(groups.length >= 1){
              $.each(groups,function(k,v){
               var channels =woker.subscribe('group'+v.id); 
                channels.on('getmessage',function(data){
                    
                    if(data.message.fromid != laychat.mine.id){
                       layui.layim.getMessage(data.message);         
                    }  
               });
               channels.on('getnow',function(data){
                 $.each(data.message,function(k,v){
                     var obj = $.parseJSON(v);
                     if(obj.fromid != laychat.mine.id){
                         layui.layim.getMessage(obj);  
                     }
                     
                 });
             });


              });
            }

              // 重连接
              woker.connection.on('state_change', function(states) {
                // states = {previous: 'oldState', current: 'newState'}
                if(states.current == 'unavailable' || states.current == 'disconnected' || states.current == 'failed' ){

                    woker.unsubscribe('user' + laychat.mine.id);
                     if(groups.length >= 1){

                        $.each(groups,function(k,v){
                     
                       woker.unsubscribe('group'+v.id);
                      });
              
                     }   
                    laychat.connect();              
                }

            });
    },
     addfriend:function(data){
      
      $.ajax({
        url:laychat.addFriendUrl,
        type:'post',
        data:data
      });

      layui.layim.addList(data.addfriend);

    },
    removefriend:function(data){
  
      $.ajax({
        url:laychat.removeFriendUrl,
        type:'post',
        data:data
      });
      layui.layim.removeList(data.removefriend);
    },
    addgroup:function(data){
  
     $.ajax({
         url:laychat.addGroupUrl,
         type:'post',
         data:data
     });

     layui.layim.addList(data.addgroup);

    },
    removegroup:function(data){

      $.ajax({
        url:laychat.leaveGroupUrl,
        type:'post',
        data:data
      });
    layui.layim.removeList(data.removegroup);

    },

    initIM  : function(){
           
          var module = laychat.isMobile ? 'mobile' : 'layim';

           layui.use(module, function(layim){
             if (laychat.isMobile) {
                var mobile = layui.mobile, 
                    layim = mobile.layim, 
                    layer = mobile.layer;
                    layui.layim = layim;
                    layui.layer = layer;
            }
            // 初始化消息
            layim.on('ready', function(options){
              console.log(options);
              $.ajax({
                 url:'https://chat1.ytlk.shop/publics/Offlinemsg',
                 type:'post',
                 data:{id:laychat.mine.id,group:laychat.groupList,app_key:laychat.app_key}
              });
            });
            
            // 监听查看群员
            layim.on('members', function(data){
                 console.log(data);
            });
            // 监听发送消息
            layim.on('sendMessage', function(res){
               // console.log(res);
              if(res.to.type == 'friend'){

                  if(res.to.fromid){
                     var newdata={
                      username: res.mine.username //消息来源用户名
                      ,avatar: res.mine.avatar //消息来源用户头像
                      ,fromid: res.mine.id 
                      ,type: res.to.type //聊天窗口来源类型，从发送消息传递的to里面获取
                      ,content: res.mine.content //消息内容
                      ,mine: true//是否我发送的消息，如果为true，则会显示在右方
                      ,id:res.mine.id   // 窗口号
                      ,toid:res.to.fromid
                      ,appkey:laychat.app_key
                    };

                 }else{
                 var newdata={
                  username: res.mine.username //消息来源用户名
                  ,avatar: res.mine.avatar //消息来源用户头像
                  ,fromid: res.mine.id 
                  ,type: res.to.type //聊天窗口来源类型，从发送消息传递的to里面获取
                  ,content: res.mine.content //消息内容
                  ,mine: true//是否我发送的消息，如果为true，则会显示在右方
                  ,id:res.mine.id
                  ,toid:res.to.id
                  ,appkey:laychat.app_key
                 };
               }
              }else{

                 if(res.to.fromid){
                       var newdata={
                        username: res.mine.username //消息来源用户名
                        ,avatar: res.mine.avatar //消息来源用户头像
                        ,fromid: res.mine.id 
                        ,type: res.to.type //聊天窗口来源类型，从发送消息传递的to里面获取
                        ,content: res.mine.content //消息内容
                        ,mine: true//是否我发送的消息，如果为true，则会显示在右方
                        ,id:res.to.id
                        ,toid:res.to.id
                        ,appkey:laychat.app_key
               
                      };
                  }else{

                     var newdata={
                      username: res.mine.username //消息来源用户名
                      ,avatar: res.mine.avatar //消息来源用户头像
                      ,fromid: res.mine.id 
                      ,type: res.to.type //聊天窗口来源类型，从发送消息传递的to里面获取
                      ,content: res.mine.content //消息内容
                      ,mine: true//是否我发送的消息，如果为true，则会显示在右方
                      ,id:res.to.id
                      ,toid:res.to.id
                      ,appkey:laychat.app_key
                    };
                   }
              }
              
                $.ajax({
                  url:laychat.sendMessageUrl,
                  type:'post',
                  data:newdata
                });
           
            });

         // 合成数据
          var data={
                  'mine':laychat.mine,
                  'friend':laychat.friendList,
                  'group':laychat.groupList
          };

         layui.layim.config({
                //初始化接口
                init: data
                // 上传图片
                ,uploadImage: {
                    url: laychat.uploadImageUrl
                }
                // 上传文件
                ,uploadFile: {
                    url: laychat.uploadFileUrl
                }
                ,isgroup: laychat.enableGroup
                ,isfriend: laychat.enableFriend
                //聊天记录地址
                ,chatLog: 'https://chat1.ytlk.shop/publics/chatlog/mine/'+laychat.mine.id
                //,find: laychat.findUrl
                ,copyright: false //是否授权
                ,title: laychat.appName
                ,min: laychat.setMin
                ,isAudio: laychat.enableAudio
                ,isVideo: laychat.enableVideo
                ,voice: laychat.voice
                ,brief: laychat.brief
                ,min: laychat.min
                ,right:laychat.right
                ,minRight:laychat.minRight
                ,initSkin:laychat.initSkin
                ,notice:laychat.notice
                ,maxLength:laychat.maxLength
                ,skin:laychat.skin
                ,members: {
                      url: laychat.membersUrl
                     ,data: {}
                  }
            });

          });
    }
  
}
    
