<!DOCTYPE html>
<html>

	<head>
		<meta charset="utf-8">
		<title>预约手术</title>
		<meta name="viewport" content="width=device-width, initial-scale=1,maximum-scale=1,user-scalable=no">
		<meta name="apple-mobile-web-app-capable" content="yes">
		<meta name="apple-mobile-web-app-status-bar-style" content="black">
		<link rel="stylesheet" href="../../css/mui.min.css">
		<link rel="stylesheet" type="text/css" href="../../css/app.css" />
		<link type="text/css" rel="stylesheet" href="../../css/ydui.css" />
		<link type="text/css" rel="stylesheet" href="../../css/demo.css" />
		<style>
			body {
				background: #f0f0f0;
			}
			
			.contentul {
				margin-top: 0.625rem !important;
				background: white !important;
				height: auto !important;
			}
			
			.contentli {
				padding: 0;
				background: white !important;
				height: auto !important;
			}
			
			.headimg {
				width: 4.125rem;
				height: 4.125rem;
				border-radius: 50%;
				margin-top: 0.9375rem;
				margin-left: 0.9375rem;
			}
			
			.name {
				position: absolute;
				margin: 0;
				left: 6rem;
				top: 0.9375rem;
				font-size: 1rem;
				color: #333333;
				font-weight: 400;
			}
			
			.title {
				position: absolute;
				margin: 0;
				left: 6rem;
				top: 2.5625rem;
				font-size: 0.8125rem;
				color: #666666;
				font-weight: 300;
			}
			
			.hospital {
				position: absolute;
				margin: 0;
				left: 6rem;
				top: 4rem;
				font-size: 0.8125rem;
				color: #666666;
				font-weight: 300;
			}
			
			.good {
				margin-left: 6rem;
				/*margin-top: 0.15625rem;*/
				margin-bottom: 0.9375rem;
				font-size: 0.8125rem;
				color: #999999;
				font-weight: 300;
				line-height: 1.25rem;
				width: calc(100% - 6.9375rem);
			}
			
			.btn {
				border-radius: 4px !important;
				background: #00CF91 !important;
				font-size: 0.8125rem !important;
				color: white !important;
				border-width: 0 !important;
				height: 1.5625rem !important;
				width: 5rem !important;
				position: absolute !important;
				right: 0.9375rem !important;
				top: 0.9375rem !important;
				padding: 0 !important;
			}
			
			.topgrid {
				background: white !important;
				height: 2.5rem;
				margin: 0 !important;
			}
			
			.bottomgrid {
				width: calc(100% - 3.375rem);
				margin-left: 1.25rem !important;
				background: white !important;
				border-width: 0 !important;
				margin-top: -0.84375rem !important;
				padding: 0 !important;
			}
			
			.topcol {
				height: 2.5rem;
				padding: 0 !important;
			}
			
			.gridtitle {
				line-height: 2.5rem !important;
				padding: 0 !important;
				margin: 0 !important;
				font-size: 0.9375rem;
				color: #333333;
				font-weight: 300;
			}
			
			.arrow {
				width: 0.62625rem;
				height: 0.375rem;
			}
			
			.m-cityselect {
				height: 50%;
			}
			
			.brouce-in {
				height: 50%;
				top: 2.5rem;
			}
			
			.arrowspan {
				clear: both !important;
			}
			/* 向下的箭头 */
			/*.item {
				float: right;
				clear: both;
				margin-bottom: 23px;
			}*/
			
			.dot-bottom {
				font-size: 0px;
				line-height: 0;
				border-width: 6px;
				border-color: black;
				border-bottom-width: 0;
				border-style: dashed;
				border-top-style: solid;
				border-left-color: transparent;
				border-right-color: transparent;
			}
			
			.cityselect-nav>a {
				padding: 0;
				margin-right: 1.5rem !important;
			}
			
			.hospitalul {
				width: 100%;
				top: 2.5rem;
				height: 200px;
				overflow: auto;
			}
			
			.listhospital {
				line-height: 3rem !important;
				margin-left: 0.9375rem;
				font-size: 0.9375rem;
				font-weight: 300;
			}
			
			.hospitalli {
				height: 3rem;
				padding: 0;
			}
			
			.mask1 {
				position: fixed;
				top: 0;
				width: 100%;
				height: 100%;
				background: rgba(1, 1, 1, 0.2);
			}
			
			.departul {
				width: 100%;
				top: 2.5rem;
				height: 200px;
				overflow: auto;
			}
			
			.listdepart {
				line-height: 3rem !important;
				margin-left: 0.9375rem;
				font-size: 0.9375rem;
				font-weight: 300;
			}
			
			.departli {
				height: 3rem;
				padding: 0;
			}
			
			.mask2 {
				position: fixed;
				top: 0;
				width: 100%;
				height: 100%;
				background: rgba(1, 1, 1, 0.2);
			}
			
			.noneimg {
				margin-top: 6.71875rem;
				margin-left: 6.9375rem;
				margin-right: 6.9375rem;
				width: calc(100% - 13.875rem);
				height: 6.84375rem;
				text-align: center;
			}
			
			.nonelabel {
				font-size: 0.8125rem;
				font-weight: normal;
				text-align: center;
				margin-top: 1.0625rem;
			}
			
			.noselect {
				border-radius: 4px !important;
				background: #00CF91 !important;
				font-size: 0.8125rem !important;
				color: white !important;
				border-width: 0 !important;
				height: 1.5625rem !important;
				width: 5rem !important;
				position: absolute !important;
				right: 0.9375rem !important;
				top: 0.9375rem !important;
				padding: 0 !important;
			}
			
			.yesselect {
				border-radius: 4px !important;
				background: #ff6c56 !important;
				font-size: 0.8125rem !important;
				color: white !important;
				border-width: 0 !important;
				height: 1.5625rem !important;
				width: 5rem !important;
				position: absolute !important;
				right: 0.9375rem !important;
				top: 0.9375rem !important;
				padding: 0 !important;
			}
			
			.div_title {
				height: 0.9375rem;
				font-size: 0.9375rem;
				font-weight: bold;
				margin-left: 0.9375rem;
				margin-top: 0.625rem;
			}
			
			.bottomcol {
				text-align: left !important;
				padding: 0 !important;
				height: 0.875rem !important;
				width: 47%;
				border-width: 0 !important;
				margin-bottom: 0.625rem !important;
				background: white !important;
				/*margin-right: 0.625rem !important;*/
				/*margin-left: 0.625rem !important;*/
				height: 1rem !important;
			}
			
			.gridtitle1 {
				font-size: 0.875rem;
				color: #333333;
				font-weight: 300;
				line-height: 1rem !important;
				margin: 0 !important;
				padding: 0 !important;
			}
			
			.img2div {
				width: calc(100% - 0.9375rem);
				margin-left: 0.9375rem;
				margin-top: 0.625rem;
				height: auto !important;
			}
			
			.img1 {
				width: 0.9375rem;
				height: 0.9375rem;
				/*margin-bottom: -0.1rem;*/
				display: block;
			}
			
			.line {
				height: 1px;
				background: #f0f0f0;
				margin-top: 0.9375rem;
				margin-left: 0.9375rem;
				width: calc(100% - 0.9375rem);
			}
			
			#empty {
				position: absolute;
				top: 2.5rem;
				height: calc(100vh - 2.5rem);
				background: #f0f0f0;
			}
			li{
				padding: 0 !important;
			}
		</style>
	</head>

	<body>
		<div class="mui-content">
			<ul class="mui-table-view mui-grid-view mui-grid-9" style="background: white;border-width: 0;margin: 0;height: 2.5rem;">
				<li class="mui-table-view-cell mui-media mui-col-xs-4 mui-col-sm-4" id="city">
					<h2 class="gridtitle">
						<label  id="cityname">城市</label>
                        <span class="item dot-bottom"></span>  
					</h2>
				</li>
				<li class="mui-table-view-cell mui-media mui-col-xs-4 mui-col-sm-4" id="hospital_name">
					<h2 class="gridtitle">
						<label  id="hospitalname">医院</label>
                        <span class="item dot-bottom"></span>  
					</h2>
				</li>
				<li class="mui-table-view-cell mui-media mui-col-xs-4 mui-col-sm-4" id="depart_name">
					<h2 class="gridtitle">
						<label  id="departname">科室</label>
                        <span class="item dot-bottom"></span>  
					</h2>
				</li>
			</ul>
			<ul class="mui-table-view contentul">
			</ul>
			<div class="mask1" id="mask1" style="display: none;">
				<ul class="mui-table-view hospitalul" id="hospitalul">
				</ul>
			</div>
			<div class="mask2" id="mask2" style="display: none;">
				<ul class="mui-table-view departul" id="departul">
				</ul>
			</div>

			<div id="empty" style="display:none">
				<img class="noneimg" src="${base.contextPath}/static/wx/images/icon_riji1.png">
				<p class="nonelabel">没有医生</p>
			</div>
		</div>
	</body>
	<script src="${base.contextPath}/static/wx/js/mui.min.js"></script>
	<script type="text/javascript" src="${base.contextPath}/static/wx/js/jquery.min.js"></script>
	<script type="text/javascript" src="${base.contextPath}/static/wx/js/ydui.citys.js"></script>
	<script type="text/javascript" src="${base.contextPath}/static/wx/js/ydui.js"></script>
	<script src="${base.contextPath}/static/wx/js/config.js"></script>
	<script>
		mui.init();
		var hospitalId = '';
		var cityId = '';
		var departId = '';
		document.getElementById('mask1').addEventListener('tap', function() {
			document.getElementById('mask1').style.display = 'none';
		})
		document.getElementById('mask2').addEventListener('tap', function() {
			document.getElementById('mask2').style.display = 'none';
		})
		//请求默认医院列表
		mui.ajax('${base.contextPath}/wxnavi/selectSurgeryDoctorList.hf', {
			data: {
				id: '${p.id}'
			},
			dataType: 'json',
			type: 'post',
			success: function(data) {
				filldefaultdoctorlist(data);
			},
			error: function(xhr, type, errorThrown) {
				mui.toast(type)
			}
		});

		function filldefaultdoctorlist(e) {
			if(e.pushList.length == 0) {
				document.getElementById('empty').style.display = 'block';
			} else {
				document.getElementById('empty').style.display = 'none';
				var table = document.body.querySelector('.mui-table-view.contentul');
				for(i = 0; i < e.pushList.length; i++) {
					var row = e.pushList[i];
					var headImg = row.headImage;
					if(!headImg){
						headImg = '${base.contextPath}/static/wx/images/doctorMale.png';
					}
					var timestr = "";
					var list = e.pushList[i].list;
					var sss = '<span style="color: #00cf91;width: 2px !important;height: 0.875rem !important;padding-left:13px;">丨</span>';
					for(var j=0;j<list.length;j++){
						var obj = list[j];
						timestr += '<li class="mui-table-view-cell mui-media mui-col-xs-4 mui-col-sm-6 bottomcol"><h2 class="gridtitle1">'+obj.timestr;
						if(j!=list.length-1){
							timestr += sss;
						}
						timestr += '</h2></li>';
					}
					var li = document.createElement('li');
					li.className = 'mui-table-view-cell contentli';
					li.setAttribute('index', i);
					li.innerHTML = '<img class="headimg" src="'+headImg+'" />\
					<button class="noselect" my-data="'+row.id+'" value="'+e.pushList[i].messagepushId+'">预约手术</button>\
					<h1 class="name">' + e.pushList[i].drName + '</h1>\
					<h2 class="title">' + e.pushList[i].deptName + ' ' + e.pushList[i].titleStr + '</h2>\
					<h3 class="hospital">' + e.pushList[i].doctorHospName + '</h3>\
					<div class="line"></div>\
					<div class="div_title">\
						<img class="img1" src="${base.contextPath}/static/wx/images/icon_c1.png" />\
						<ul class="mui-table-view mui-grid-view mui-grid-9 bottomgrid">\
							<li class="mui-table-view-cell mui-media mui-col-xs-4 mui-col-sm-6 bottomcol">\
								<h2 class="gridtitle1">'+list[0].hospName+'</h2>\
							</li>\
						</ul>\
					</div>\
					<div class="img2div">\
						<img class="img1" src="${base.contextPath}/static/wx/images/icon_c2.png" />\
						<ul class="mui-table-view mui-grid-view mui-grid-9 bottomgrid">'+timestr+'</ul>\
					</div>';
					table.insertBefore(li, table.lastChild);
					
					
					
					/*var row = e.pushList[i];
					var headImg = row.headImage;
					if(!headImg||headImg!=''){
						headImg = '${base.contextPath}/static/wx/images/doctorMale.png';
					}
					var li = document.createElement('li');
					li.className = 'mui-table-view-cell contentli';
					li.setAttribute('index', i);
					li.innerHTML = '<img class="headimg" src="'+headImg+'" />\
					<button class="noselect" my-data="'+row.id+'" value="'+row.messagepushId+'">预约手术</button>\
					<h1 class="name">' + e.pushList[i].drName + '</h1>\
					<h2 class="title">' + e.pushList[i].deptName + ' ' + e.pushList[i].titleStr + '</h2>\
					<h3 class="hospital">' + e.pushList[i].hospName + '</h3>\
					<h4 class="good">擅长：' + e.pushList[i].special + '</h4>';
					table.insertBefore(li, table.lastChild);*/
				}
				mui(".contentli button").each(function(index, item){
					item.addEventListener('tap', function() {
							mui.openWindow({
								id: 'registrationfeedback',
								url: '${domain}wxnavi/doctordetail2.hf?messageId='+item.value,
								//url: 'https://open.weixin.qq.com/connect/oauth2/authorize?appid=${appid}&redirect_uri=${domain}wxnavi%2foperation.hf&response_type=code&scope=snsapi_base&state='+item.value+'#wechat_redirect',
								show: {
									aniShow: 'fade-in',
									duration: 300
								},
								waiting: {
									autoShow: false
								}
							});
					});
				});
			}
		}

		//选择地区
		! function() {
			var $target = $('#city');
			$target.citySelect();
			$target.on('click', function(event) {
				event.stopPropagation();
				$target.citySelect('open');
			});
			$target.on('done.ydui.cityselect', function(ret) {
				document.getElementById('cityname').innerHTML = ret.city;
				cityId = ret.id;

			});
		}();

		function fillhospital(e) {
			var table = document.body.querySelector('.mui-table-view.hospitalul');
			for(i = 0; i < e.rows.length; i++) {
				var li = document.createElement('li');
				li.className = 'mui-table-view-cell hospitalli';
				li.setAttribute('index', i);
				li.innerHTML = '<h1 class="listhospital">' + e.rows[i].name + '</h1>';
				table.insertBefore(li, table.lastChild);
			}
            document.getElementById('mask1').style.display = 'block';
			mui(".hospitalli").each(function(index, item) {
				item.addEventListener('tap', function() {
					//选中医院列表
					document.getElementById('mask1').style.display = 'none';
					document.getElementById('hospitalname').innerHTML = e.rows[index].name;
					hospitalId = e.rows[index].id;
					//选完医院请求医生列表
					mui.ajax('${base.contextPath}/wxnavi/selectSurgeryDoctorList.hf', {
						data: {
							id: '${p.id}',
							hospitalId: hospitalId
						},
						dataType: 'json',
						type: 'post',
						success: function(data) {
							var table = document.body.querySelector('.mui-table-view.contentul');
							while(table.hasChildNodes()) //删除上一次请求的数据
							{
								table.removeChild(table.firstChild);
							}
							filldefaultdoctorlist(data);
						},
						error: function(xhr, type, errorThrown) {
							mui.toast(type)
						}
					});
				});
			})
		}

		document.getElementById('hospital_name').addEventListener('tap', function() {
			if(document.getElementById('cityname').innerHTML == '城市') {
				mui.toast('请先选择城市')
				return false;
			}
			//选完城市请求医院
			mui.ajax('${base.contextPath}/wxnavi/selectHospitalByCityId.hf', {
				data: {
					cityId: cityId
				},
				dataType: 'json',
				type: 'post',
				success: function(data) {
					var table = document.body.querySelector('.mui-table-view.hospitalul');
					//删除上一次请求的医院列表
					while(table.hasChildNodes()) {
						table.removeChild(table.firstChild);
					}
					if(data.rows.length == 0) {
						mui.toast('当前城市没有医院')
					} else {
						fillhospital(data);
					}
				},
				error: function(xhr, type, errorThrown) {
					mui.toast(type)
				}
			});
		})

		document.getElementById('depart_name').addEventListener('tap', function() {
			if(document.getElementById('hospitalname').innerHTML == '医院') {
				mui.toast('请先选择医院')
				return false;
			} else {
				//选完医院请求科室列表
				mui.ajax('${base.contextPath}/wxnavi/selectDepartmentByHospitalId.hf', {
					data: {
						hospitalId: hospitalId,
						pid:'${p.id}'
					},
					dataType: 'json',
					type: 'post',
					success: function(data) {
						var table = document.body.querySelector('.mui-table-view.departul');
						while(table.hasChildNodes()) //删除上一次请求的数据
						{
							table.removeChild(table.firstChild);
						}
						if(data.depList.length == 0) {
							mui.toast('当前医院没有科室') //当前医院没有科室
						} else {
							filldepart(data);
						}
					},
					error: function(xhr, type, errorThrown) {
						mui.toast(type)
					}
				});

			}
		})

		function filldepart(e) {
			var table = document.body.querySelector('.mui-table-view.departul');
			for(i = 0; i < e.depList.length; i++) {
				var li = document.createElement('li');
				li.className = 'mui-table-view-cell departli';
				li.setAttribute('index', i);
				li.innerHTML = '<h1 class="listdepart">' + e.depList[i].deptName + '</h1>';
				table.insertBefore(li, table.lastChild);
			}
			document.getElementById('mask2').style.display = 'block';
			mui(".departli").each(function(index, item) {
				item.addEventListener('tap', function() {
					//选中科室列表 请求医生列表
					document.getElementById('mask2').style.display = 'none';
					document.getElementById('departname').innerHTML = e.depList[index].deptName;
                    departId = e.depList[index].departmentId;
					mui.ajax('${base.contextPath}/wxnavi/selectSurgeryDoctorList.hf', {
						data: {
							id: '${p.id}',
							departmentId: departId
						},
						dataType: 'json',
						type: 'post',
						success: function(data) {
							var table = document.body.querySelector('.mui-table-view.contentul');
							while(table.hasChildNodes()) //删除上一次请求的数据
							{
								table.removeChild(table.firstChild);
							}
							filldefaultdoctorlist(data);
						},
						error: function(xhr, type, errorThrown) {
							mui.toast(type)
						}
					});
				});
			})
		}
	</script>

</html>